#include "IDIBUS_1xGen.h"

IdiBus_1xGen::IdiBus_1xGen (IdiBusSerialLine *SlaveLine, uint8_t SlaveAddress) : IdiBusSlave(SlaveLine, SlaveAddress)
{
	TMP.MMES_Error = 0;
	TMP.RXlen = 0;
}

IdiBus_1xGen::IdiBus_1xGen () : IdiBusSlave()
{
	TMP.MMES_Error = 0;
	TMP.RXlen = 0;
}

IDIBUS_1xGEN_DATA_TYPE IdiBus_1xGen::getData(void)
{
	return this->TMP;
}

// setters
void IdiBus_1xGen::setFirstModeTime (uint8_t FirstTime) {
	first_mode_time = FirstTime;
}

void IdiBus_1xGen::setFirstModePWM (uint16_t FirstPWM) {
	first_mode_pwm_value = FirstPWM;
}

void IdiBus_1xGen::setFirstModeF (uint32_t FirstF) {
	first_mode_f = FirstF;
}

void IdiBus_1xGen::setFirstModeInvert (uint8_t FirstInvert) {
	first_mode_invert = FirstInvert;
}

void IdiBus_1xGen::setSecondModeTime (uint8_t SecondTime) {
	second_mode_time = SecondTime;
}

void IdiBus_1xGen::setSecondModePWM (uint16_t SecondPWM) {
	second_mode_pwm_value = SecondPWM;
}

void IdiBus_1xGen::setSecondModeF (uint32_t SecondF) {
	second_mode_f = SecondF;
}

void IdiBus_1xGen::setSecondModeInvert (uint8_t SecondInvert) {
	second_mode_invert = SecondInvert;
}

// getters
uint8_t IdiBus_1xGen::getFirstModeTime () {
	return first_mode_time;
}

uint16_t IdiBus_1xGen::getFirstModePWM () {
	return first_mode_pwm_value;
}

uint32_t IdiBus_1xGen::getFirstModeF () {
	return first_mode_f;
}

uint8_t IdiBus_1xGen::getFirstModeInvert () {
	return first_mode_invert;
}

uint8_t IdiBus_1xGen::getSecondModeTime () {
	return second_mode_time;
}

uint16_t IdiBus_1xGen::getSecondModePWM () {
	return second_mode_pwm_value;
}

uint32_t IdiBus_1xGen::getSecondModeF () {
	return second_mode_f;
}

uint8_t IdiBus_1xGen::getSecondModeInvert () {
	return second_mode_invert;
}

uint8_t IdiBus_1xGen::startGen(void) {
	//uint8_t buf[10] = {this->first_mode_time,
		//(uint8_t)((this->first_mode_pwm_value >> 8) & 0xFF), (uint8_t)(this->first_mode_pwm_value & 0xFF),
		//this->first_mode_f, this->first_mode_invert,
		//this->second_mode_time,
		//(uint8_t)((this->second_mode_pwm_value >> 8) & 0xFF), (uint8_t)(this->second_mode_pwm_value & 0xFF),
	//this->second_mode_f, this->second_mode_invert};
	
	uint8_t buf[16] = {this->first_mode_time,
	(uint8_t)((this->first_mode_pwm_value >> 8) & 0xFF), (uint8_t)(this->first_mode_pwm_value & 0xFF),

	(uint8_t)((this->first_mode_f >> 24) & 0xFF), 
	(uint8_t)((this->first_mode_f >> 16) & 0xFF),
	(uint8_t)((this->first_mode_f >> 8) & 0xFF),
	(uint8_t)(this->first_mode_f & 0xFF),
	
	this->first_mode_invert,
	//
	this->second_mode_time,
	(uint8_t)((this->second_mode_pwm_value >> 8) & 0xFF), (uint8_t)(this->second_mode_pwm_value & 0xFF),
	
	(uint8_t)((this->second_mode_f >> 24) & 0xFF),
	(uint8_t)((this->second_mode_f >> 16) & 0xFF),
	(uint8_t)((this->second_mode_f >> 8) & 0xFF),
	(uint8_t)(this->second_mode_f & 0xFF),
	
	this->second_mode_invert};
	
	IdiBusMMES MMES(this->Address);
	MMES.DEV.NUM	= IDIBUS_1xGen_DEV;
	MMES.CHNL.NUM   = 0;
	MMES.ComFunc    = 0x01;
	MMES.TxDataLength = 16;
	MMES.TxData = buf;
	uint8_t RequestError = this->SendRequestMMES(&MMES);
	
	if      ( RequestError   != IDIER_NOPE )          { this->TMP.MMES_Error = RequestError;   }
	else if ( MMES.RxDataLength == 1 )                { this->TMP.MMES_Error = MMES.RxData[0]; }
	else {
		this->TMP.MMES_Error = IDIERMST_INVALID_RX_REQUEST_FORMAT;
	}
	return this->TMP.MMES_Error;
}

uint8_t IdiBus_1xGen::resetGen() {
	IdiBusMMES MMES(this->Address);
	MMES.DEV.NUM	= IDIBUS_1xGen_DEV;
	MMES.CHNL.NUM   = 0;
	MMES.ComFunc    = 0x02;
	
	uint8_t ChDataSize = 0;
	uint8_t RequestError = this->SendRequestMMES(&MMES);
	
	if      ( RequestError   != IDIER_NOPE )          { this->TMP.MMES_Error = RequestError;   }
	else if ( MMES.RxDataLength == 1 )                { this->TMP.MMES_Error = MMES.RxData[0]; }
	else {
		this->TMP.MMES_Error = IDIERMST_INVALID_RX_REQUEST_FORMAT;
	}
	return this->TMP.MMES_Error;
}