#ifndef IDIBUS_1XGEN_H_
#define IDIBUS_1XGEN_H_

#include "IdiBusSlave.h"

enum IDIBUS_1xGen_MODULE_DEVICES_LIST {
	IDIBUS_1xGen_DEV = 0x00,
	IDIBUS_1xGen_DEVICES_NUMBER
};

typedef struct {
	uint8_t RXlen;
	uint8_t RXbuf[255];
	uint8_t MMES_Error;  //	Last error
} IDIBUS_1xGEN_DATA_TYPE;

class IdiBus_1xGen : public IdiBusSlave {
	public:
		IdiBus_1xGen(IdiBusSerialLine *SlaveLine, uint8_t SlaveAddress);
		IdiBus_1xGen();
		
		uint8_t startGen();
		uint8_t resetGen();
		
		IDIBUS_1xGEN_DATA_TYPE getData();
		
		void setFirstModeTime (uint8_t FirstTime);
		void setFirstModePWM (uint16_t FirstPWM);
		void setFirstModeF (uint32_t FirstF);
		void setFirstModeInvert (uint8_t FirstInvert);
		
		void setSecondModeTime (uint8_t SecondTime);
		void setSecondModePWM (uint16_t SecondPWM);
		void setSecondModeF (uint32_t SecondF);
		void setSecondModeInvert (uint8_t SecondInvert);
		
		uint8_t getFirstModeTime ();
		uint16_t getFirstModePWM ();
		uint32_t getFirstModeF ();
		uint8_t getFirstModeInvert ();
		
		uint8_t getSecondModeTime ();
		uint16_t getSecondModePWM ();
		uint32_t getSecondModeF ();
		uint8_t getSecondModeInvert ();

	protected:
		IDIBUS_1xGEN_DATA_TYPE TMP;
		
	private:
		uint8_t first_mode_time;
		uint16_t first_mode_pwm_value;
		uint32_t first_mode_f;
		uint8_t first_mode_invert;
		
		uint8_t second_mode_time;
		uint16_t second_mode_pwm_value;
		uint32_t second_mode_f;
		uint8_t second_mode_invert;
};

#endif /* IDIBUS_1XGEN_H_ */