//#############################################################################################################################################################################################################
#include "IdiBusMes.h"
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
uint8_t IdiBusMessage::IsGroupAddr(void) { return ( (this->SlAddr >= IDIBUS_GROUP_0_ADDR)&&(this->SlAddr <= IDIBUS_GROUP_15_ADDR) ) ? 1 : 0; }
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
uint8_t IdiBusMessage::IsCommand(void)   { return ( this->ComFunc >= IDIMMES_COM_START_NUM ) ? 1 : 0; }
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
uint8_t IdiBusMessage::IsModuleError(uint8_t ErrCode) { return ((ErrCode >= IDIER_MODULE_NUM_START)&&(ErrCode <= IDIER_MODULE_NUM_END)) ? 1 : 0; }
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
uint8_t IdiBusMessage::IsModuleCommand(void)
{
 switch (this->ComFunc)
	{
	 case(IDIMMES_COM_C_Init)               :
	 case(IDIMMES_COM_C_ShtDown)            :
	 case(IDIMMES_COM_C_Freeze)             :
	 case(IDIMMES_COM_C_Resume)             :
	 case(IDIMMES_COM_C_SetAlarmL12)        :
	 case(IDIMMES_COM_C_SetAlarmL)          :
	 case(IDIMMES_COM_C_SyncRead)           :
	 case(IDIMMES_COM_C_SyncDoChnl)         :
	 case(IDIMMES_COM_C_SyncDo)             :
	 case(IDIMMES_COM_C_SyncClear)          :
	 case(IDIMMES_COM_C_SendTimeDate)       :
	 case(IDIMMES_COM_C_MkTimedMaster)      :
	 case(IDIMMES_COM_C_FmwUpd)             :
	 case(IDIMMES_COM_C_EndFmwUpd)          :
	 case(IDIMMES_COM_C_FmwWrite)           :
	 case(IDIMMES_COM_C_ReadDevFullSN_MS)   :
	 case(IDIMMES_COM_C_WriteSnIPv4IPv6)    :
	 case(IDIMMES_COM_C_WriteSnVerifyDates) :
	 case(IDIMMES_COM_C_WriteSnAES256)      :
	 case(IDIMMES_COM_C_DummyModule)        : 
	 case(IDIMMES_COM_C_CheckModuleLongOp)  : { return 1; }
	 default : {}
 	}
 return 0;
}
//=============================================================================================================================================================================================================
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//=============================================================================================================================================================================================================
IdiBusMMES::IdiBusMMES (uint8_t SlAddr, uint8_t *TX_DataP, uint16_t TX_DataLength)
{
 this->SlAddr = SlAddr;
 this->MMPS.LongMes = 0;
 this->MMPS.AlarmMes = 0;
 this->MMPS.EncryptedAes = 0;
 this->DEV.NUM = 0;
 this->DEV.ALLCH = 0;
 this->CHNL.ALLSAME = 0;
 this->CHNL.NUM = 0;
 this->ComFunc = 1;

 this->TxData = TX_DataP;
 this->TxDataLength = TX_DataLength;
 this->RxData = NULL;
 this->RxDataLength = 0;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
IdiBusMMES::IdiBusMMES (uint8_t SlAddr)
{
 this->SlAddr = SlAddr;
 this->MMPS.LongMes = 0;
 this->MMPS.AlarmMes = 0;
 this->MMPS.EncryptedAes = 0;
 this->DEV.NUM = 0;
 this->DEV.ALLCH = 0;
 this->CHNL.ALLSAME = 0;
 this->CHNL.NUM = 0;
 this->ComFunc = IDIMMES_COM_C_Dummy;

 this->TxData = NULL;
 this->TxDataLength = 0;
 this->RxData = NULL;
 this->RxDataLength = 0;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
uint8_t IdiBusMMES::IsValid(void)
{
 if ( (this->ComFunc == 0) || this->IsModuleCommand() || this->IsGroupAddr() ) { return 0; }
 return 1;
}
//=============================================================================================================================================================================================================
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//=============================================================================================================================================================================================================
IdiBusMMESG::IdiBusMMESG (uint8_t SlAddr, uint8_t *TX_DataP, uint16_t TX_DataLength)
{
 this->SlAddr = SlAddr;
 this->MMPS.LongMes = 0;
 this->MMPS.AlarmMes = 0;
 this->MMPS.EncryptedAes = 0;
 this->ComFunc = IDIMMES_COM_C_DummyModule;

 this->TxData = TX_DataP;
 this->TxDataLength = TX_DataLength;
 this->RxData = NULL;
 this->RxDataLength = 0;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
IdiBusMMESG::IdiBusMMESG (uint8_t SlAddr)
{
 this->SlAddr = SlAddr;
 this->MMPS.LongMes = 0;
 this->MMPS.AlarmMes = 0;
 this->MMPS.EncryptedAes = 0;
 this->ComFunc = IDIMMES_COM_C_Dummy;

 this->TxData = NULL;
 this->TxDataLength = 0;
 this->RxData = NULL;
 this->RxDataLength = 0;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
uint8_t IdiBusMMESG::IsValid(void)
{
 uint8_t isModuleCommand = this->IsModuleCommand();
 uint8_t isGroupAddress  = this->IsGroupAddr();
 
 if ( this->ComFunc == IDIMMES_NOT_FAST_FUNC ) { return 0; }
 if ( isGroupAddress )
	{
	 if ( isModuleCommand != 0 ) { return 0; }
	}
	else if ( isModuleCommand == 0 ) { return 0; }
 return 1;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//#############################################################################################################################################################################################################
