//#############################################################################################################################################################################################################
#ifndef _IDIBUS_MES_H_
#define _IDIBUS_MES_H_
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#include "IdiBusSystem.h"
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
class IdiBusMessage {
	public :
		uint8_t	    SlAddr;
		struct {
			uint8_t LongMes		 : 1;
			uint8_t AlarmMes     : 1;
			uint8_t EncryptedAes : 1;
			} MMPS;
		uint8_t  ComFunc;
		uint8_t *TxData;
		uint16_t  TxDataLength;
		uint8_t *RxData;
		uint16_t  RxDataLength;
	
		uint8_t IsGroupAddr(void);
		uint8_t IsModuleCommand(void);
		uint8_t IsCommand(void);
		uint8_t IsModuleError(uint8_t ErrCode);
};
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
class IdiBusMMES : public IdiBusMessage {
	public :
		IdiBusMMES (uint8_t SlAddr, uint8_t *TX_DataP, uint16_t TX_DataLength);
		IdiBusMMES (uint8_t SlAddr);
		struct {
			uint8_t NUM   : 5;
			uint8_t ALLCH : 1;
			} DEV;
		struct {
			uint8_t NUM     : 7;
			uint8_t ALLSAME : 1;
			} CHNL;
		uint8_t IsValid(void);
};
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
class IdiBusMMESG : public IdiBusMessage {
	public :
		IdiBusMMESG (uint8_t SlAddr, uint8_t *TX_DataP, uint16_t TX_DataLength);
		IdiBusMMESG (uint8_t SlAddr);
		uint8_t IsValid(void);
};
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#endif //#define _IDIBUS_MES_H_
//#############################################################################################################################################################################################################
